#pragma once

class Shadow
{
public:
	Shadow(Shader* shader, Vector3& at, float radius, float width = 1024, float height = 1024);
	~Shadow();

	void PreRender();
	
	ID3D11ShaderResourceView* SRV() {return renderTarget->SRV(); }

public:
	struct Desc
	{
		Matrix View;
		Matrix Projection;
	}desc;

private:
	Shader* shader;

	float width, height;
	
	float radius; //Projection  뵵
	Vector3 at;

	RenderTarget* renderTarget;
	DepthStencil* depthStencil;
	Viewport* viewport;

	ConstantBuffer* buffer;
	ID3DX11EffectConstantBuffer* sBuffer;


};